#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const ink_1 = require("ink");
const ink_big_text_1 = __importDefault(require("ink-big-text"));
const repl_ns_1 = require("repl-ns");
const ink_form_1 = require("ink-form");
const ink_spinner_1 = __importDefault(require("ink-spinner"));
const ytdl_core_muxer_1 = __importDefault(require("ytdl-core-muxer"));
const fs_1 = __importDefault(require("fs"));
const jotai_1 = require("jotai");
const mainNS = (0, repl_ns_1.ns)('main', {
    Main: () => {
        const [url, setUrl] = (0, jotai_1.useAtom)(mainNS().url$);
        const [path, setPath] = (0, jotai_1.useAtom)(mainNS().path$);
        const [downloaded, setDownloaded] = (0, jotai_1.useAtom)(mainNS().downloaded$);
        const [downloadInProgress, setDownloadInProgress] = (0, jotai_1.useAtom)(mainNS().downloadInProgress$);
        const [downloadError, setDownloadError] = (0, jotai_1.useAtom)(mainNS().downloadError$);
        return (React.createElement(ink_1.Box, { flexDirection: "column" },
            React.createElement(ink_1.Box, null,
                React.createElement(ink_big_text_1.default, { text: "YOUTUBE DOWNLOAD" })),
            React.createElement(ink_1.Box, { marginBottom: 1 }, downloadInProgress ? (React.createElement(ink_spinner_1.default, { type: "aesthetic" })) : downloaded ? (React.createElement(ink_1.Text, { color: 'green' }, "\u2705 Video downloaded!")) : downloadError ? (React.createElement(ink_1.Text, { color: 'red' }, downloadError.message)) : null),
            React.createElement(ink_1.Box, null,
                React.createElement(ink_form_1.Form, { ...mainNS().formProps({ url, path }, { setUrl, setPath }), onSubmit: obj => {
                        setDownloaded(() => false);
                        setDownloadInProgress(() => true);
                        mainNS().onDownload(obj, { setDownloaded, setDownloadInProgress, setDownloadError });
                    } }))));
    },
    formProps: ({ url, path }, { setUrl, setPath, }) => ({
        onChange: (state) => {
            setUrl(() => state.url);
            setPath(() => state.path);
        },
        form: {
            title: 'Please setup form for downloading video from Youtube',
            sections: [
                {
                    title: '',
                    fields: [
                        {
                            type: 'string',
                            name: 'url',
                            label: 'Youtube URL',
                            regex: RegExp('^https://.*$'),
                            initialValue: url,
                        },
                        {
                            type: 'string',
                            name: 'path',
                            label: 'File location',
                            initialValue: path || `${process.cwd()}/video.mp4`,
                        },
                    ],
                },
            ],
        },
    }),
    onDownload(obj, { setDownloaded, setDownloadInProgress, setDownloadError, }) {
        (0, ytdl_core_muxer_1.default)(obj.url)
            .on('error', err => {
            setDownloadInProgress(() => false);
            setDownloaded(() => false);
            setDownloadError(() => err);
        })
            .pipe(fs_1.default.createWriteStream(obj.path))
            .on('finish', () => {
            setDownloadInProgress(() => false);
            setDownloaded(() => true);
            setDownloadError(() => null);
        });
    },
    url$: (0, jotai_1.atom)(''),
    path$: (0, jotai_1.atom)(''),
    downloaded$: (0, jotai_1.atom)(false),
    downloadInProgress$: (0, jotai_1.atom)(false),
    downloadError$: (0, jotai_1.atom)(null),
});
(async () => {
    await mainNS.ready;
    const Main = mainNS().Main;
    (0, ink_1.render)(React.createElement(Main, null));
})();
